#include "globals.h"
#include "bitmaps/filing48.xbm"

#define XtNupdateInterval	"updateInterval"
#define XtCUpdateInterval	"UpdateInterval"

typedef struct
{
  int nSeconds;
} UpdateResData;

static XtResource resources[] = {
  {
	XtNupdateInterval,
	XtCUpdateInterval,
	XtRInt,
	sizeof( int ),
	XtOffsetOf( UpdateResData, nSeconds ),
	XtRImmediate,
	(XtPointer)60
  }
};

void initFM( 
#if NeedFunctionPrototypes
	XtPointer 
#endif
);
void autoUpdate(
#if NeedFunctionPrototypes
        XtPointer
#endif
);

Pixmap 		iconPixmap;
Widget 		toplevel;
XtAppContext 	appContext;
UpdateResData 	updateResData;


main( argc, argv )
  int argc;
  char **argv;
{
  Pixmap p;
  Pixel fg, bg;
  XmString xms;
  Widget form, pixmapLabel, textLabel;

  toplevel = XtVaAppInitialize( &appContext, "Mfm",
                 NULL, 0, &argc, argv, NULL,
                 XmNheight, 200,
                 XmNwidth, 400,
                 NULL );

  readApplicationResources( toplevel );
  readDevApplicationResources( toplevel );
  XtVaGetApplicationResources( toplevel, &updateResData, resources,
	XtNumber(resources), NULL );

  XtRealizeWidget( toplevel );

  createErrorAndWarningDialogs( toplevel );

  iconPixmap = XCreateBitmapFromData( XtDisplay(toplevel),
	DefaultRootWindow(XtDisplay(toplevel)), filing48_bits,
        filing48_width, filing48_height );
  XtVaSetValues( toplevel, XmNiconPixmap, iconPixmap, NULL );

  xms = XmStringCreateLtoR( "mfm - version 1.3\nCreated By Andrew T. Renalds\n\n\nInitializing, Please Wait...", XmSTRING_DEFAULT_CHARSET );

  form = XtVaCreateManagedWidget( "form",
		xmFormWidgetClass, toplevel, NULL );
  pixmapLabel = XtVaCreateManagedWidget( "pixmapLabel",
		xmDrawnButtonWidgetClass, form,
		XmNtopAttachment, XmATTACH_FORM,
		XmNtopOffset, 10,
		XmNbottomAttachment, XmATTACH_FORM,
                XmNbottomOffset, 10,
		XmNleftAttachment, XmATTACH_FORM,
                XmNleftOffset, 10,
		XmNrightAttachment, XmATTACH_OPPOSITE_FORM,
		XmNrightOffset, -80,
		XmNlabelType, XmPIXMAP,
		NULL );
  textLabel = XtVaCreateManagedWidget( "textLabel",
		xmLabelWidgetClass, form,
		XmNtopAttachment, XmATTACH_FORM,
                XmNtopOffset, 10,
                XmNbottomAttachment, XmATTACH_FORM,
                XmNbottomOffset, 10,
                XmNleftAttachment, XmATTACH_FORM,
                XmNleftOffset, 90,
                XmNrightAttachment, XmATTACH_FORM,
                XmNrightOffset, 10,
		XmNlabelString, xms,
		NULL );
  XmStringFree( xms );

  XtVaGetValues( pixmapLabel, XmNforeground, &fg, XmNbackground, &bg, NULL );
  p = XCreatePixmapFromBitmapData( XtDisplay(pixmapLabel),
        DefaultRootWindow(XtDisplay(pixmapLabel)), filing48_bits,
        filing48_width, filing48_height, fg, bg,
        DefaultDepthOfScreen( XtScreen(pixmapLabel) ) );
  XtVaSetValues( pixmapLabel, XmNlabelPixmap, p, NULL );

  XtAppAddTimeOut( appContext, 1000, 
	(XtTimerCallbackProc)initFM, (XtPointer)NULL );
  XFlush( XtDisplay(toplevel) );
  XSync( XtDisplay(toplevel), False );

  XtAppMainLoop( appContext );
}

void initFM( xtp )
  XtPointer xtp;
{
  initDD( toplevel );
  allocateFileManager( toplevel, LOCAL_FILESYSTEM, "", "", "" );
  XtUnmapWidget( toplevel );
  XtAppAddTimeOut( appContext, 60000,
	(XtTimerCallbackProc)autoUpdate, (XtPointer)NULL );
}

void autoUpdate( xtp )
  XtPointer xtp;
{
  updateAllFileManagers();
  XtAppAddTimeOut( appContext, updateResData.nSeconds*1000,
        (XtTimerCallbackProc)autoUpdate, (XtPointer)NULL );
}
